/*       CONECTAR            Ignacio  Merino  Lagunilla                       */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <strings.h>
#include <netdb.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "global.hpp"

//#define 	DEBUG


int monitor::conectar(void)
{
 int puerto;
 struct sockaddr_in dir;
 struct hostent *host;
 struct linger opcion;
 fd_set test;
 struct timeval espera;

	if( (sock = socket(AF_INET , SOCK_STREAM , 0) ) < 0)
	{
		printf("\aERROR: No puedo crear el socket.\n");
		if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo crear el socket.\n");
		return(-3);
	}
#ifdef DEBUG
	printf("Creo el socket sd = %d\n" , sock);
	if(fichero == CIERTO) fprintf(accion , "Creo el socket sd = %d\n" , sock);
#endif
	if( (host = gethostbyname(servidor) ) == NULL)
	{
        	printf("\aERROR: No puedo acceder a los datos del servidor '%s'.\n" , servidor);
        	if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo acceder a los datos del servidor '%s'.\n" , servidor);
		close(sock);
		return(-4);
	}
#ifdef DEBUG
	printf("Obtengo los datos del servidor '%s'\n" , servidor);
	if(fichero == CIERTO) fprintf(accion , "Obtengo los datos del servidor '%s'\n" , servidor);
#endif
	bzero((char *) &dir , sizeof(struct sockaddr_in));
	dir.sin_family = host->h_addrtype;
	memcpy((char *) &dir.sin_addr , host->h_addr , host->h_length);
	dir.sin_port = htons(puerto_m);
	if(connect(sock , (struct sockaddr *) &dir , sizeof(dir)) < 0)
	{
        	printf("\aERROR: No puedo conectarme con el servidor '%s'.\n" , servidor);
		if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo conectarme con el servidor '%s'.\n" , servidor);
		close(sock);
		return(-5);
	}
#ifdef DEBUG
	printf("Conectado al servidor '%s'\n" , servidor);
	if(fichero == CIERTO) fprintf(accion , "Conectado al servidor '%s'\n" , servidor);
#endif
	opcion.l_linger = 5;
	opcion.l_onoff = 1;
	setsockopt(sock , SOL_SOCKET , SO_LINGER , &opcion , sizeof(opcion));
#ifdef DEBUG
	printf("Socket %d de cierre diferido\n" , sock);
	if(fichero == CIERTO) fprintf(accion , "Socket %d de cierre diferido\n" , sock);
#endif
	espera.tv_sec = 3;
	espera.tv_usec = 0;
	FD_ZERO(&test);
	FD_SET(sock , &test);
	select(sock+1 , SOCKET &test , NULL , NULL , &espera);
	if(FD_ISSET(sock , &test))
	{
		read(sock , msg_entra , MAX_MSG);
		if(sscanf(msg_entra , "MNP%d" , &puerto) < 0)
		{
			printf("\aERROR: Mensaje incorrecto del servidor.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: Mensaje incorrecto del servidor.\n");
			close(sock);
			return(-6);
		}
#ifdef DEBUG
		printf("Calculo el puerto %d\n" , puerto);
		if(fichero == CIERTO) fprintf(accion , "Calculo el puerto %d\n" , puerto);
#endif
	}
	else
	{
		printf("\aERROR: El servidor no responde.\n");
		if(fichero == CIERTO) fprintf(accion , "ERROR: El servidor no responde.\n");
		close(sock);
		return(-7);
	}
	strcpy(msg_sale , "MAP");
	enviar_msg(sock);
#ifdef DEBUG
	printf("Mando el mensaje '%s'\n" , msg_sale);
	if(fichero == CIERTO) fprintf(accion , "Mando el mensaje '%s'\n" , msg_sale);
#endif
	close(sock);
	if( (sock = socket(AF_INET , SOCK_STREAM , 0) ) < 0)
	{
		printf("\aERROR: No puedo crear el socket.\n");
		if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo crear el socket.\n");
		return(-8);
	}
#ifdef DEBUG
	printf("Creo el socket sd= %d\n" , sock);
	if(fichero == CIERTO) fprintf(accion , "Creo el socket sd= %d\n" , sock);
#endif
	dir.sin_port = htons(puerto);
	if(connect(sock , (struct sockaddr *) &dir , sizeof(dir) ) < 0)
	{
		printf("\aERROR: No puedo conectarme con el servidor '%s'.\n" , servidor);
		if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo conectarme con el servidor '%s'.\n" , servidor);
		close(sock);
		return(-9);
	}
#ifdef DEBUG
	printf("Conectado al servidor '%s'\n" , servidor);
	if(fichero == CIERTO) fprintf(accion , "Conectado al servidor '%s'\n" , servidor);
#endif
	opcion.l_linger = 5;
	opcion.l_onoff = 1;
	setsockopt(sock , SOL_SOCKET , SO_LINGER , &opcion , sizeof(opcion));
#ifdef DEBUG
	printf("Socket %d de cierre diferido\n" , sock);
	if(fichero == CIERTO) fprintf(accion , "Socket %d de cierre diferido\n" , sock);
#endif
	recibir_msg(sock , "MDM" , 0);
	sscanf(msg_entra , "MDM%d %d" , &maxx , &maxy);
#ifdef DEBUG
	printf("Conexion establecida con el al servidor '%s'\n" , servidor);
	if(fichero == CIERTO) fprintf(accion , "Conexion establecida con el servidor '%s'\n" , servidor);
#endif
	conectado = CIERTO;
	return(0);
}

void monitor::desconectar(void)
{
	strcpy(msg_sale , "MHT");
	enviar_msg(sock);
#ifdef DEBUG
	printf("Envio el mensaje de fin '%s' al servidor\n" , msg_sale);
	if(fichero == CIERTO) fprintf(accion , "Envio el mensaje de fin '%s' al servidor\n" , msg_sale);
#endif
	conectado = FALSO;
	acabar = CIERTO;
	recibir_msg(sock , "MPT" , 0);
	shutdown(sock , 2);
}

void monitor::parar(void)
{
	if(activo == CIERTO)
	{
		strcpy(msg_sale , "MHP");
		enviar_msg(sock);
		activo = FALSO;
		ventana->poner_informacion();
#ifdef DEBUG
		printf("Paro al proceso monitor\n");
		if(fichero == CIERTO) fprintf(accion , "Paro al proceso monitor\n");
#endif
	}
	else
	{
		strcpy(msg_sale , "MHC");
		enviar_msg(sock);
		activo = CIERTO;
		ventana->poner_informacion();
#ifdef DEBUG
		printf("Mando continuar al proceso monitor\n");
		if(fichero == CIERTO) fprintf(accion , "Mando continuar al proceso monitor\n");
#endif
		ventana->redibujar(1);
	}
#ifdef DEBUG
	printf("Envio el mensaje de paro/marcha '%s' al servidor\n" , msg_sale);
	if(fichero == CIERTO) fprintf(accion , "Envio el mensaje de paro/marcha '%s' al servidor\n" , msg_sale);
#endif
}
