/******************************************************************************\
*                                                                              *
*       VENTANA             Ignacio  Merino  Lagunilla                         *
*                                                                              *
*       Funciones para crear una ventana donde mostrar informacin.            *
*                                                                              *
*       22/febrero/1994                                                        *
\******************************************************************************/

#ifndef _VENTANA_
#define _VENTANA_

#include <X11/Xlib.h>
#include <X11/Xutil.h>

extern int	maxx;
extern int	maxy;

#define NUM_COLOR	16

class ventana_info{
	private:
		Display *display;
		Window window;
		GC gc;
		XEvent evento;
		unsigned long colores[NUM_COLOR];
		float escala;
		int origen_x;
		int origen_y;
	public:
		inline ventana_info(void) { escala = 1; origen_x = origen_y = 0; };
		inline ~ventana_info(void) { };
		void crear(void);
		void liberar(void);
		inline unsigned long di_color(int i) { return(colores[i]); }
		void comprobar_eventos(void);
		void dibujar_punto(void);
		void dibujar_recta(void);
		void dibujar_poligono(void);
		void dibujar_circulo(void);
		void dibujar_sector(void);
		void dibujar_texto(void);
		void redibujar(int borrar);
		inline float di_escala(void) { return(escala); }
		inline void fijar_escala(float esc) { escala = esc; redibujar(1); }
		inline void inc_escala(void) { if(escala < 10) { escala+=0.1; redibujar(1); } }
		inline void dec_escala(void) { if(escala > 0.3) { escala-=0.1; redibujar(1); } }
    		void dec_origen_x(void);
		void inc_origen_x(void);
		inline void fijar_origen_x(int org) { origen_x = org; }
		inline int di_origen_x(void) { return(origen_x); }
		void dec_origen_y(void);
		void inc_origen_y(void);
		inline void fijar_origen_y(int org) { origen_y = org; }
		inline int di_origen_y(void) { return(origen_y); }
		void poner_informacion(void);
};

#endif
