/******************************************************************************\
*                                                                              *
*       MAPA                Ignacio  Merino  Lagunilla                         *
*                                                                              *
*       Funciones para gestionar el mapa del mundo.                            *
*                                                                              *
*       22/febrero/1995                                                        *
\******************************************************************************/

#ifndef _MAPA_
#define _MAPA_

#include <stdio.h>
#include "coord.hpp"

class mapa_mundo{
	private:
		unsigned char *plano;
		int maxx;
		int maxy;
	public:
		inline mapa_mundo(void) { plano = NULL; }
		inline ~mapa_mundo(void) { if(plano != NULL) delete(plano); }
		int crear(void);
		int escribir(char *fich , int copia);
		inline int di_maxx(void) { return(maxx); }
		inline int di_maxy(void) { return(maxy); }
		unsigned char di_punto(int x , int y);
		int punto(int x , int y , unsigned char color);
		int recta(int x1 , int y1 , int x2 , int y2 , unsigned char color);
		void poligono(int xc , int yc , float ang , int n , punto_pol *p , unsigned char color);
		void circulo(int x , int y , int r , unsigned char color);
		int rellenar(int sx , int sy , int d , int axl , int axr , unsigned char color);
};

#endif
