/*       CREAR               Ignacio  Merino  Lagunilla                       */

#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#include "global.hpp"

//#define		DEBUG


robot::robot(void)
{
	ini_s = fin_s = NULL;
	ini_m = fin_m = NULL;
	v1 = v2 = 0;
	dibu_sen = dibu_rastro = FALSO;
	activo = CIERTO;
}

robot::~robot(void)
{
	if(ini_s != NULL) delete(ini_s);
	if(ini_m != NULL) delete(ini_m);
}

int robot::crear(char *f_rob)
{
 FILE *rob;
 char linea[100];
 int x , y , rango , dis;
 float ang , an , interv , ang_sec;
 register unsigned char i;
 laser *plaser;
 sonar *psonar;
 GPS *pGPS;

	printf("Fichero de descripcion del robot: ");
	scanf("%s" , f_rob);
	if ((rob = fopen(f_rob , "rt")) == NULL)
	{
		printf("\aERROR: No puedo abrir el fichero '%s'.\n" , f_rob);
		if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo abrir el fichero '%s'.\n" , f_rob);
		return (-1);
	}
#ifdef DEBUG
	printf("Abro el fichero '%s' del robot\n" , f_rob);
	if(fichero == CIERTO) fprintf(accion , "Abro el fichero '%s' del robot\n" , f_rob);
#endif
	while( !feof(rob) )
	{
		i = 0; while( isalpha( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
		if( strcmp(linea , "C") == 0)
		{
			while((i = fgetc(rob) ) != '\n');
#ifdef DEBUG
			printf("Leo una linea de comentario\n");
			if(fichero == CIERTO) fprintf(accion , "Leo una linea de comentario\n");
#endif
		}
		else if( strcmp(linea , "nombre") == 0)
		{
			i = 0; while( isalnum( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
                        strncpy(nombre , linea , 5); nombre[5] = '\0';
#ifdef DEBUG
			printf("Leo el nombre del robot, nombre = '%s'\n" , nombre);
			if(fichero == CIERTO) fprintf(accion , "Leo el nombre del robot, nombre = '%s'\n" , nombre);
#endif
		}
		else if( strcmp(linea , "posicion") == 0)
		{
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			x = atoi(linea);
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			y = atoi(linea);
			pos.fijar_punto(x , y);
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			angulo = radianes( atoi(linea) );
#ifdef DEBUG
			printf("Leo la posicion del robot x = %d y = %d angulo = %d\n" , x , y , grados(angulo) );
			if(fichero == CIERTO) fprintf(accion , "Leo la posicion del robot x = %d y = %d angulo = %d\n" , x , y , grados(angulo) );
#endif
		}
		else if( strcmp(linea , "aspecto") == 0)
		{
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			radio = atoi(linea);
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			ruedas = atoi(linea);
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			color = atoi(linea);
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			rastro = atoi(linea);
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			sentido = atoi(linea);
#ifdef DEBUG
			printf("Leo el aspecto del robot radio = %d ruedas = %d color = %d rastro = %d sentido = %d\n" , radio , ruedas , color , rastro , sentido);
			if(fichero == CIERTO) fprintf(accion , "Leo el aspecto del robot radio = %d ruedas = %d color = %d rastro = %d sentido = %d\n" , radio , ruedas , color , rastro , sentido);
#endif
		}
		else if( strcmp(linea , "sensorlaser") == 0)
		{
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			dis = atoi(linea);
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			ang = radianes( atoi(linea) );
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			an = radianes( atoi(linea) );
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			rango = atoi(linea);
#ifdef DEBUG
			printf("Leo el sensor laser del robot distancia = %d angulo = %d orientacion = %d rango = %d\n" , dis , grados(ang) , grados(an) , rango);
			if(fichero == CIERTO) fprintf(accion , "Leo el sensor laser del robot distancia = %d angulo = %d orientacion = %d rango = %d\n" , dis , grados(ang) , grados(an) , rango);
#endif
			if( (plaser = new laser) == NULL)
			{
				printf("\aERROR: No hay memoria suficiente para el sensor laser distancia = %d angulo = %d orientacion = %d rango = %d.\n" , dis , grados(ang) , grados(an) , rango);
				if(fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria suficiente para el sensor laser distancia = %d angulo = %d orientacion = %d rango = %d.\n" , dis , grados(ang) , grados(an) , rango);
				fclose(rob);
				return(-2);
			}
			plaser->crear(ini_s , fin_s , dis , ang , an , rango);
#ifdef DEBUG
			printf("Creo el sensor laser del robot distancia = %d angulo = %d orientacion = %d rango = %d\n" , dis , grados(ang) , grados(an) , rango);
			if(fichero == CIERTO) fprintf(accion , "Creo el sensor laser del robot distancia = %d angulo = %d orientacion = %d rango = %d\n" , dis , grados(ang) , grados(an) , rango);
#endif
		}
		else if( strcmp(linea , "sensorsonar") == 0)
		{
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			dis = atoi(linea);
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			ang = radianes( atoi(linea) );
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			an = radianes( atoi(linea) );
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			rango = atoi(linea);
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			ang_sec = radianes( atoi(linea) );
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			interv = radianes( atoi(linea) );
			i = 0; while( isdigit( linea[i++] = fgetc(rob) ) ); linea[--i] = '\0';
			x = atoi(linea); if(x != 1 && x != 2 && x != 3) x = 2;
#ifdef DEBUG
			printf("Leo el sensor sonar del robot distancia = %d angulo = %d orientacion = %d rango = %d sector %d intervalo %d tipo %d\n" , dis , grados(ang) , grados(an) , rango , grados(ang_sec) , grados(interv) , x);
			if(fichero == CIERTO) fprintf(accion , "Leo el sensor sonar del robot distancia = %d angulo = %d orientacion = %d rango = %d sector %d intervalo %d tipo %d\n" , dis , grados(ang) , grados(an) , rango , grados(ang_sec) , grados(interv) , x);
#endif
			if( (psonar = new sonar) == NULL)
			{
				printf("\aERROR: No hay memoria suficiente para el sensor sonar distancia = %d angulo = %d orientacion = %d rango = %d sector %d intervalo %d tipo %d.\n" , dis , grados(ang) , grados(an) , rango , grados(ang_sec) , grados(interv) , x);
				if(fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria suficiente para el sensor sonar distancia = %d angulo = %d orientacion = %d rango = %d sector %d intervalo %d tipo %d.\n" , dis , grados(ang) , grados(an) , rango , grados(ang_sec) , grados(interv) , x);
				fclose(rob);
				return(-3);
			}
			psonar->crear(ini_s , fin_s , dis , ang , an , rango , ang_sec , interv , x);
#ifdef DEBUG
			printf("Creo el sensor sonar del robot distancia = %d angulo = %d orientacion = %d rango = %d sector %d intervalo %d tipo %d\n" , dis , grados(ang) , grados(an) , rango , grados(ang_sec) , grados(interv) , x);
			if(fichero == CIERTO) fprintf(accion,"Creo el sensor sonar del robot distancia = %d angulo = %d orientacion = %d rango = %d sector %d intervalo %d tipo %d\n" , dis , grados(ang) , grados(an) , rango , grados(ang_sec) , grados(interv) , x);
#endif
		}
		else if( strcmp(linea , "sensorGPS") == 0)
		{
#ifdef DEBUG
			printf("Leo el sensor GPS del robot\n");
			if(fichero == CIERTO) fprintf(accion , "Leo el sensor GPS del robot\n");
#endif
			if( (pGPS = new GPS) == NULL)
			{
				printf("\aERROR: No hay memoria suficiente para el sensor GPS.\n");
				if(fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria suficiente para el sensor GPS.\n");
				fclose(rob);
				return(-4);
			}
			pGPS->crear(ini_s , fin_s);
#ifdef DEBUG
			printf("Creo el sensor GPS\n");
			if(fichero == CIERTO) fprintf(accion , "Creo el sensor GPS\n");
#endif
		}
	}
	fclose(rob);
#ifdef DEBUG
	printf("Creo el robot '%s'\n" , nombre);
	if(fichero == CIERTO) fprintf(accion , "Creo el robot '%s'\n" , nombre);
#endif
	return(0);
}

void robot::ver_sensores(void)
{
	if(conectado == CIERTO)
	{
		sprintf(msg_sale , "RMS");
		enviar_msg(sock);
#ifdef DEBUG
		printf("El proceso robot '%s' quiere dibujar los sensores\n" , nombre);
		if(fichero == CIERTO) fprintf(accion , "El proceso robot '%s' quiere dibujar los sensores\n" , nombre);
#endif
	}
}

void robot::no_ver_sensores(void)
{
	if(conectado == CIERTO)
	{
		sprintf(msg_sale , "ROS");
		enviar_msg(sock);
#ifdef DEBUG
		printf("El proceso robot '%s' no quiere dibujar los sensores\n" , nombre);
		if(fichero == CIERTO) fprintf(accion , "El proceso robot '%s' no quiere dibujar los sensores\n" , nombre);
#endif
	}
}

void robot::ver_rastro(void)
{
	if(conectado == CIERTO)
	{
		sprintf(msg_sale , "RMR");
		enviar_msg(sock);
#ifdef DEBUG
		printf("El proceso robot '%s' quiere dibujar el rastro\n" , nombre);
		if(fichero == CIERTO) fprintf(accion , "El proceso robot '%s' quiere dibujar el rastro\n" , nombre);
#endif
	}
}

void robot::no_ver_rastro(void)
{
	if(conectado == CIERTO)
	{
		sprintf(msg_sale , "ROR");
		enviar_msg(sock);
#ifdef DEBUG
		printf("El proceso robot '%s' no quiere dibujar el rastro\n" , nombre);
		if(fichero == CIERTO) fprintf(accion , "El proceso robot '%s' no quiere dibujar el rastro\n" , nombre);
#endif
	}
}

