/******************************************************************************\
*                                                                              *
*       ROBOT               Ignacio  Merino  Lagunilla                         *
*                                                                              *
*       Funciones que describen el comportamiento del robot.                   *
*                                                                              *
*       22/febrero/1995                                                        *
\******************************************************************************/

#ifndef _ROBOT_
#define _ROBOT_

#include <stdio.h>
#include "sensor.hpp"
#include "mensaje.hpp"

class robot{
	private:
		int sock;							// socket
		char nombre[6];					// nombre
		punto_car pos;						// posicion
		float angulo;						// orientacion
		float v1 , v2;						// velocidades en las ruedas
		int radio , ruedas;					// radio y distancia entre ruedas
		int dibu_sen;						// dibujar_sensores
		int dibu_rastro;					// dibujar rastro
		unsigned char color , rastro , sentido;	// colores
		int choques;						// numero de choques
		int activo;						// si esta activo o no
		sensor *ini_s;						// inicio lista sensores
		sensor *fin_s;						// fin lista sensores
		mensaje *ini_m;					// inicio lista mensajes
		mensaje *fin_m;					// fin lista mensajes
	public:
		robot(void);
		~robot(void);
		inline int di_sock(void) { return(sock); }
		inline char* di_nombre(void) { return(nombre); }
		inline punto_car* di_pos(void) { return(&pos); }
		inline void fijar_angulo(float ang) { angulo = ang; }
		inline float di_angulo(void) { return(angulo); }
		inline float di_v1(void) { return(v1); }
		inline float di_v2(void) { return(v2); }
		inline sensor* di_ini_s(void) { return(ini_s); }
		inline mensaje* di_ini_m(void) { return(ini_m); }
		inline int di_choques(void) { return(choques); }
		inline int di_activo(void) { return(activo); }
		int crear(char *f_rob);
		int conectar(void);
		int enviar_datos(void);
		void desconectar(void);
		inline void leer_sensores(void) { ini_s->explorar_sensores(this); }
		void recibir_msg(int socket,char codigo[3] , int opc);
		void enviar_msg(int socket);
		void decidir(void);
		void ver_sensores(void);
		void no_ver_sensores(void);
		void ver_rastro(void);
		void no_ver_rastro(void);
		void parar(void);
};

#endif
