/*       SOCKET              Ignacio  Merino  Lagunilla                       */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>

#include "global.hpp"

//#define 	DEBUG


void salir(void)
{
	printf("Termino la ejecucion del programa.\n");
	if(fichero == CIERTO) fprintf(accion , "Termino la ejecucion del programa.\n");
	ventana->liberar();
	close(rob->di_sock());
	if(rob != NULL) delete(rob);
	if(ventana != NULL) delete(ventana);
	if(ini_ri != NULL) delete(ini_ri);
	if(fichero == CIERTO) fclose(accion);
	exit(20);
}

void robot::enviar_msg(int socket)
{
 fd_set test;
 int escritos = 0 , n = 0 , veces = 0;
 struct timeval espera;

	while(escritos < MAX_MSG)
	{
		FD_ZERO(&test);
		FD_SET(socket , &test);
		espera.tv_sec = 0;
		espera.tv_usec = veces * 1000;
		select(socket + 1 , NULL , SOCKET &test , NULL , &espera);
		if(FD_ISSET(socket , &test))
		{
			n = write(socket , &msg_sale[escritos] , MAX_MSG - escritos);
			if(n >= 0) escritos+=n;
			else
			{
				printf("\aERROR: Error en el envio de un mensaje al servidor.\nMejor me suicido.\n");
				if(fichero == CIERTO) fprintf(accion , "ERROR: Error en el envio de un mensaje al servidor.\nMejor me suicido.\n");
				salir();
			}
		}
		if(veces++ == 400)
		{
			printf("\aERROR: No puedo mandar mensajes al servidor.\nMejor me suicido.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo mandar mensajes al servidor.\nMejor me suicido.\n");
			salir();
		}
	}
}

void robot::recibir_msg(int socket , char codigo[3] , int opc)
{
 char cod[4]={ '\0' , '\0' , '\0' , '\0' };
 static char origen[6] , datos[45];
 mensaje *mens;
 robot_inf *aux;
 fd_set test;
 int leidos , n = 0 , veces1 = 0 , veces2 = 0;
 struct timeval espera;

	if(opc > 100) opc = 100;
	while(strcmp(cod , codigo) != 0)
 	{
		FD_ZERO(&test);
		FD_SET(socket , &test);
		espera.tv_sec = 0;
		espera.tv_usec = veces2 * 1000;
		select(socket+1 , SOCKET &test , NULL , NULL , &espera);
		if(FD_ISSET(socket , &test))
		{
			leidos = 0; veces1 = 0;
			while(leidos < MAX_MSG)
			{
				FD_ZERO(&test);
				FD_SET(socket , &test);
				espera.tv_sec = 0;
				espera.tv_usec = veces1 * 1000;
				select(socket+1 , SOCKET &test , NULL , NULL , &espera);
				if(FD_ISSET(socket , &test))
				{
					n = read(socket , &msg_entra[leidos] , MAX_MSG - leidos);
					if(n >= 0) leidos+=n;
					else
					{
						printf("\aERROR: No puedo recibir mensajes del servidor.\nMejor me suicido.\n");
						if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo recibir mensajes del servidor.\nMejor me suicido.\n");
						salir();
					}
				}
				if(veces1++ == 400)
				{
					printf("\aERROR: No puedo recibir mensajes del servidor.\nMejor me suicido.\n");
					if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo recibir mensajes del servidor.\nMejor me suicido.\n");
					salir();
				}
			}
#ifdef DEBUG
			printf("Recibo el mensaje '%s'\n" , msg_entra);
			if(fichero == CIERTO) fprintf(accion , "Recibo el mensaje '%s'\n" , msg_entra);
#endif
			veces2 = 0;
			strncpy(cod , msg_entra , 3);
			if(strcmp(cod , codigo) != 0 || opc != 0)
			{
				if(strcmp(cod , "RPY") == 0) { activo = FALSO; ventana->redibujar(); }
				else if(strcmp(cod , "RCY") == 0) { activo = CIERTO; ventana->redibujar(); }
				else if(strcmp(cod , "RNR") == 0)
				{
					sscanf(msg_entra , "RNR%s" , origen);
					printf("Se conecta el robot '%s'\n" , origen);
					if(fichero == CIERTO) fprintf(accion , "Se conecta el robot '%s'\n" , origen);
					if((aux = new robot_inf(origen)) == NULL)
					{
						printf("\aERROR: No hay memoria suficiente para el robot '%s'.\n" , origen);
						if(fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria suficiente para el robot '%s'.\n" , origen);
					}
				}
				else if(strcmp(cod , "RBR") == 0)
				{
					sscanf(msg_entra , "RBR%s" , origen);
					printf("Se desconecta el robot '%s'\n" , origen);
					if(fichero == CIERTO) fprintf(accion , "Se desconecta el robot '%s'\n" , origen);
					ini_ri->borrar(origen);
				}
				else if(strcmp(cod , "RTC") == 0)
				{
					if((++choques % 500) == 0)
					{
						aux = ini_ri;
						while(aux != NULL)
						{
							sprintf(msg_sale , "REM%s Me_he_chocado_%d_veces" , aux->di_nombre() , choques);
							enviar_msg(sock);
							aux = aux->di_sig();
						}
					}
				}
				else if(strcmp(cod , "MEM") == 0)
				{
					sscanf(msg_entra , "MEM%s %s" , origen , datos);
					printf("Recivo el mensaje '%s' del robot '%s'\n" , datos , origen);
					if(fichero == CIERTO) fprintf(accion , "Recivo el mensaje '%s' del robot '%s'\n" , datos , origen);
					if((mens = new mensaje(ini_m , fin_m , origen , datos)) == NULL)
					{
						printf("\aERROR: No hay memoria suficiente para el mensaje '%s' del robot '%s'.\n" , datos , origen);
						if(fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria suficiente para el mensaje '%s' del robot '%s'.\n" , datos , origen);
					}
				}
				else if(strcmp(cod , "FEM") == 0)
				{
					printf("\aERROR: Al enviar el mensaje '%s'.\n" , msg_entra);
					if(fichero == CIERTO) fprintf(accion , "ERROR: Al enviar el mensaje '%s'.\n" , msg_entra);
				}
				else if(strcmp(cod , "RFY") == 0) salir();
				else
				{
					printf("\aERROR: No entiendo el mensaje '%s'.\n" , msg_entra);
	        			if(fichero == CIERTO) fprintf(accion , "ERROR: No entiendo el mensaje '%s'.\n" , msg_entra);
				}
			}
		}
		if(veces2++ == 400)
		{
			printf("\aERROR: No recibo mensajes del servidor.\nMejor me suicido.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: No recibo mensajes del servidor.\nMejor me suicido.\n");
			salir();
		}
		if(opc == 1) return;
		if(opc > 1) --opc;
	}
}
